from simtk.openmm.app import *
from simtk.openmm import *
from simtk.unit import *
from sys import stdout
from openmmtorch import TorchForce
from timeit import default_timer as timer

#import sys
#NODE_ID = sys.argv[1]
#GPU_ID = sys.argv[2]
#PROCESS_ID = sys.argv[3]

#ID = int(NODE_ID) * 12 + int(GPU_ID) * 3 + int(PROCESS_ID)

ID = 0

pdb = PDBFile('start_pdbs/ala2_sample_%d.pdb' % ID)
forcefield = ForceField('amber99sbildn.xml')
system = forcefield.createSystem(pdb.topology, nonbondedMethod=NoCutoff, constraints=HBonds, hydrogenMass=4.*amu)
f = TorchForce('../output/Ala2_qt_scripted_0.pt')
system.addForce(f)
integrator = LangevinIntegrator(300*kelvin, 1/picosecond, 0.004*picoseconds)
platform = Platform.getPlatformByName('CUDA')
properties = {'CudaDeviceIndex': GPU_ID}
simulation = Simulation(pdb.topology, system, integrator, platform, properties)
simulation.context.setPositions(pdb.positions)
#simulation.loadCheckpoint("chkpts/csimu_chkpt_%d_-1.chkpt" % ID)
simulation.reporters.append(DCDReporter('traj/csimu_10ns_output_%d_%d.dcd' % (ID, 0), 500))

start = timer()
#simulation.step(2500000)
simulation.step(25000)
stop = timer()
simulation.saveCheckpoint("chkpts/csimu_chkpt_%d_0.chkpt" % ID)
print('Benchmarking: 1 ns simulation = %f s real time' % ((stop - start) * 10.))

